package com.madeu.controller.web.webstocksumadjustmentdetail;

import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webstocksumadjustmentdetail.WebStockSumAdjustmentDetailService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebStockSumAdjustmentDetailController extends ManagerDraftAction{

	@Autowired
	private WebStockSumAdjustmentDetailService webStockSumAdjustmentDetailService;
	
	@Autowired
	private WebLogHistoryService webLogHistoryService;
	
	
	/**
	 * 제품별 실시간 재고 현황 상세 리스트 (재고조정 팝업 화면)
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksumadjustmentdetail/selectListStockSumAdjustmentDetail.do")
	public ModelAndView selectListStockSumAdjustmentDetail(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockSumAdjustmentDetailController selectListStockSumAdjustmentDetail START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumAdjustmentDetailService.selectListStockSumAdjustmentDetail(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockSumAdjustmentDetailController selectListStockSumAdjustmentDetail END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**	
	 *  제품별 실시간 재고 현황 (재고조정 팝업 화면) 저장
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksumadjustmentdetail/insertStockAdjustmentDetail.do")
	public ModelAndView insertStockAdjustmentDetail(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
		log.debug("WebStockSumAdjustmentDetailController insertStockAdjustmentDetail START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumAdjustmentDetailService.insertStockAdjustmentDetail(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

			try {
				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
				HashMap<String, Object> insertMap = new HashMap<String, Object>();
	
				insertMap.put("url", "/webstocksumadjustmentdetail/insertStockAdjustmentDetail.do");
				insertMap.put("func", "insertStockAdjustmentDetail");
				insertMap.put("funcName", "제품별 실시간 재고 현황 (재고조정 팝업 화면) 저장");
				insertMap.put("service", "webStockSumAdjustmentDetailService");
				insertMap.put("serviceName", "제품별 실시간 재고 현황 (재고조정 팝업 화면) 저장");
				insertMap.put("requestValue", String.valueOf(paramMap));
				insertMap.put("responseValue", String.valueOf(map));
				insertMap.put("tId", map.get("tId"));
				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
					insertMap.put("resultCode", "SUCCESS");
				}
				else{
					insertMap.put("resultCode", "ERROR");
				}
				insertMap.put("resultMsg", String.valueOf(errorMsg));
				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
	
				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("WebStockSumAdjustmentDetailController insertStockAdjustmentDetail END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
}
